/**
 *
 * Converte un file RTF in una stringa
 *
 * @author     Giulio "Chalda" Bettega
 * @license    http://opensource.org/licenses/gpl-license.php GNU Public License
 * @link       http://blog.chalda.it/convertire-un-documento-rtf-in-testo-in-php-10.html
 * @param      string  $filename  L'url
 * @return     string  Il file convertito in testo semplice
 *
 */
function rtf2txt($filename){

   // Recupero il file
   $handle = fopen($filename, "r");
   $rtf = fread($handle, filesize($filename));
   fclose($handle);

   // Tolgo le intestazioni
   $text = substr($rtf, strpos($rtf, '\par '));

   // Converto i caratteri speciali
   $special = array('e1'=>'á', 'c0'=>'À', 'e0'=>'à', 'c9'=>'É', 'e9'=>'é', 'c8'=>'È', 'e8'=>'è', 'cd'=>'Í', 'ed'=>'í', 'cc'=>'Ì', 'ec'=>'ì', 'd3'=>'Ó', 'f3'=>'ó', 'd2'=>'Ò', 'f2'=>'ò', 'da'=>'Ú', 'fa'=>'ú', 'd9'=>'Ù', 'f9'=>'ù', '80'=>'€', 'd1'=>'Ñ', 'f1'=>'ñ', 'c7'=>'Ç', 'e7'=>'ç', 'dc'=>'Ü', 'fc'=>'ü', 'bf'=>'¿', 'a1'=>'¡', 'b7'=>'·', 'a9'=>'©', 'ae'=>'®', 'ba'=>'º', 'aa'=>'ª', 'b2'=>'²', 'b3'=>'³');
   foreach($special as $key => $val){
      $text = str_replace('\\\\'.$key, $val, $text);
   }

   // Rimuovo i tag
   $text = preg_replace('/'.preg_quote('\\').'[a-z0-9]+/', '', $text);
   $text = str_replace('}{', '', $text);

   // Pulizia finale
   $text = substr($text, strpos($text,'*')-1, -2);
   $text = preg_replace('/ {2,}/', ' ', $text);

   return $text;
}
